#!/usr/bin/env bash

cd $MINER_DIR/$MINER_VER
export LD_LIBRARY_PATH=.

MINER_LOG_BASEDIR=`dirname "$MINER_LOG_BASENAME"`
[[ ! -d $MINER_LOG_BASEDIR ]] && mkdir -p $MINER_LOG_BASEDIR

touch $MINER_LOG_BASENAME.log

# remove tmp dirs
while read -r d; do
  [[ "$d" =~ (\/tmp\/[^\\]+)\/solvers ]] && echo "Removing ${BASH_REMATCH[1]}" && rm -r "${BASH_REMATCH[1]}"
done < <( realpath /tmp/*/solvers 2>/dev/null )

source ${MINER_DIR}/${MINER_VER}/miner.conf

AMDCNT=`gpu-detect AMD`
NVCNT=`gpu-detect NVIDIA`

for pool in "${POOLS[@]}"; do
  echo "Using ${WHITE}$pool${NOCOLOR}"
  wd delay $(( (AMDCNT+NVCNT)*5 + 1 ))
  # usage: tonpool run [-h] [-p PLATFORM] [-d DEVICE] [-t THREADS] [-ll {10,20,30,40,50}] [POOL] [WALLET]
  rmfile_from_symlink stats.json
  mkfile_from_symlink stats.json
  ./danila-miner run --stats $CONFIG $pool $WALLET 2>&1 | tee --append $MINER_LOG_BASENAME.log
  [[ $? -gt 127 ]] && break
done
